Description

Apparently, the bookkeeping has changed in a way that breaks the previously-working eventbuilder_diskwriting example. If the
combined_eb_and_dl example is not supported behavior, it should be removed.

The problem appears to be in generating sources/destinations tables when an expected layer of the artdaq system is missing. In
eventbuilder_diskwriting, there are no DatalLoggers, but there is a Dispatcher. In combined_eb_and_dl, there are no EventBuilders.

Associated revisions

Revision ed68950e - 02/07/2019 02:48 PM - John Freeman

JCF: if a subsystem has eventbuilders and dispatchers but no dataloggers, connect the eventbuilder to the dispatcher

This is in respond to Issue #21856, where Eric noticed that runs with
the eventbuilder_diskwriting configuration had problems in that events
weren't making it from the eventbuilder to the dispatcher (no
dataloggers exist in the run). With this commit, I've added logic to
bookkeeping whereby, if DAQInterface determines there are no
dataloggers in a subsystem in question, then if there are dispatchers
they'll expect to receive events from eventbuilders rather than
dataloggers.

History

#1 - 02/06/2019 03:17 PM - John Freeman

eventbuilder_diskwriting should definitely be fixed as it should be possible to send events to dispatchers from eventbuilders. However, thinking about
combined_eb_and_dl, perhaps the convention should be that if we have just one process doing the work of an eventbuilder and a datalogger, it
should be an eventbuilder - in fact, this is the convention which was used on protoDUNE. Also, having said that, it sounds like
eventbuilder_diskwriting already covers that functionality. Perhaps this makes combined_eb_and_dl redundant, in which case I'll delete it from the
configs list.

#2 - 02/07/2019 03:00 PM - John Freeman

- % Done changed from 0 to 100

With branch feature/issue21856_eventbuilders_can_send_to_dispatchers, I've done two things to DAQInterface:

1) When bookkeeping, if DAQInterface determines that a subsystem has eventbuilders and dispatchers but not dataloggers, it'll set up the sources
and destinations tables so events go from eventbuilders to dispatchers. This has gotten the eventbuilder_diskwriting configuration to work (see, e.g.,
mu2edaqg01:/home/jcfree/run_records/2119)

2) I've removed combined_eb_and_dl configuration, for the reasons | described above

#3 - 02/07/2019 03:00 PM - John Freeman

- Status changed from New to Resolved

#4 - 02/08/2019 03:06 PM - Eric Flumerfelt
- Co-Assignees Eric Flumerfelt added

Code review: No issues found

#5 - 02/08/2019 04:12 PM - Eric Flumerfelt

During testing, | get a segfault in the Dispatcher art process when it starts.
#6 0x00007£819655a0d2 in _ assert_fail () from /1ib64/libc.so.6
#7 0x00007£819be54f8d in art::Principal::Principal (this=0x3el107c0, pc=..., hist=..., presentProducts=..., ma
pper=..., reader=...)

at /scratch/workspace/art-release-build/SLF7/debug/build/art/v2_11_01/src/art/Framework/Principal/Principa
L. @28 75
#8 0x00007£819bedb699 in art::EventPrincipal::EventPrincipal (this=0x3el107c¢0, aux=..., pc=..., presentProduct
s=..., history=..., mapper=..., rtrv=..., lastInSubRun=false)

at /scratch/workspace/art-release-build/SLF7/debug/build/art/v2_11_01/src/art/Framework/Principal/EventPri
ncipal.cc:28
#9 0x00007£80838b834e in art::SourceHelper::makeEventPrincipal (this=0x3dce728, eventAux=..., history=...)

at /scratch/workspace/art-release-build/SLF7/debug/build/art/v2_11_01/src/art/Framework/I0O/Sources/SourceH
elper.cc:87
#10 0x00007£800160aebc in art::ArtdaglInput<art::NetMonWrapper>::readAndConstructPrincipal (this=0x3dce7c8, msg

., msg_type_code=4, inR=0x85185b0, inSR=0x87e67c0, outR=@0x7ffdc5fd3048: 0xO,

outSR=Q@0x7£fdc5£fd3040: 0x0, outE=Q0x7ffdc5fd3038: 0x0) at /home/eflumerf/Desktop/artdag-mrb-base/srcs/artd
ag/artdaq/ArtModules/ArtdagInput.hh:416
#11 0x00007£8001602b92 in art::Artdaglnput<art::NetMonWrapper>::readNext (this=0x3dce7c8, inR=0x85185b0, inSR=
0x87e67c0, outR=Q0x7ffdc5£fd3048: 0x0, outSR=Q@0x7ffdc5fd3040: 0x0, outE=Q@0x7ffdc5fd3038: 0x0)

at /home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag/artdag/ArtModules/ArtdagInput.hh:591

Principal.cc:

Principal::Principal (ProcessConfiguration consté& pc,
ProcessHistoryID consté& hist,
cet::exempt_ptr<ProductTable const> presentProducts,
std: :unique_ptr<BranchMapper>&& mapper,
std::unique_ptr<DelayedReader>&& reader)
processConfiguration_{pc}

, presentProducts_{presentProducts}

, branchMapperPtr_{std::move (mapper) }

, store_{std::move (reader) }

if (!'hist.isValid()) {
return;
}
assert (!ProcessHistoryRegistry::empty());
ProcessHistory ph;
bool const found[[gnu::unused]]{ProcessHistoryRegistry::get (hist, ph)};
assert (found); // Line 75
std: :swap (processHistory_, ph);

#6 - 02/08/2019 04:14 PM - Eric Flumerfelt

I think this might be due to the fact that the Dispatcher is receiving events from two different art processes with different configuration.

[eflumerf@ironwork artdag-mrb-base]$ cd run_records/1l/

[eflumerf@ironwork 1]$ 1s

boot.txt componentO0l.fcl component02.fcl Dispatcherl.fcl EventBuilderl.fcl EventBuilder2.fcl known_board
readers_list.txt metadata.txt ranks.txt setup.txt

[eflumerf@ironwork 1]$ diff EventBuilder*

2c2

< # Input : ./EventBuilderl.fcl

> # Input : ./EventBuilder2.fcl

67c67

< fileName: "/home/eflumerf/Desktop/artdag-mrb-base/dagdata/artdagdemo_eb00_r%06r_sr%02s_%to_%#_ebl.root
n

> fileName: "/home/eflumerf/Desktop/artdag-mrb-base/dagdata/artdagdemo_eb00_r%06r_sr%02s_%to_%#_eb2.root

#7 - 02/08/2019 04:21 PM - Eric Flumerfelt

| get the following errors trying to run a different configuration:

Fri Feb 8 16:21:07 CST 2019: CONFIG transition underway
Config name: demo

Obtaining FHiCL documents...done (0.0 seconds).
Bookkeeping the FHiCL documents...Traceback (most recent call last):
File "/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/rc/control/daginterface.py", line 1607
, in do_config
self.bookkeeping_for_fhicl_documents ()
File "/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/rc/control/bookkeeping.py", line 376,
in bookkeeping_for_fhicl_documents_artdag v3_base
"\n } \n" + \
File "/home/eflumerf/Desktop/artdag-mrb-base/srcs/artdag_daginterface/rc/control/bookkeeping.py", line 302,
in create_sources_or_destinations_string
elif not procinfo_subsystem _has_dataloggers and "Dispatcher" in procinfo_to_check.name and nodetype == "de

stinations":
UnboundLocalError: local variable 'procinfo_subsystem_has_dataloggers' referenced before assignment

#8 - 02/10/2019 11:41 AM - John Freeman

Concerning the local variable 'procinfo_subsystem_has_dataloggers' referenced before assignment error: the problem there is this code snippet from
bookkeeping.py:

procinfo_subystem_has_dataloggers = True
if len([pi for pi in self.procinfos if pi.subsystem == procinfo.subsystem and pi.name == "DataLogger"]
) == 0:
procinfo_subsystem_has_dataloggers = False

...where on that first line, | leave out an "s" in "subsystem". The upshot of this is that if a subsystem DOES have a datalogger (like in the demo config,
which | didn't test with, but unlike in the eventbuilder_diskwriting config, which | did test with), the procinfo_subsystem_has_dataloggers variable
doesn't get set. Fixed by commit 79ef998d00eeb80272622cbed35fc036235a5ca2 on feature/issue21856_eventbuilders_can_send_to_dispatchers.
Moral of the story: after a code change, test all control paths!

#9 - 03/26/2019 08:42 AM - Eric Flumerfelt
| have made a couple changes to the fhicl configuration for the eventbuilder_diskwriting simple_test_config, and changed the default for the

disable_unique_rootfile_labels option. With these changes, the eventbuilder_diskwriting example now works correctly.

#10 - 03/26/2019 08:43 AM - Eric Flumerfelt

- Status changed from Resolved to Reviewed
